using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Net;

using System.IO;

namespace Google_Maps_Download
{
    public partial class GMdl_2ndTryDL : Form
    {
        private DataTable missing_tiles;

        private string map_name;

        public GMdl_2ndTryDL(DataTable Missing_tiles, string Map_name)
        {
            InitializeComponent();
            
            missing_tiles = Missing_tiles.Copy(); // so removing rows doesn't give an error (works?)
            map_name = Map_name;

            Grid.DataSource = missing_tiles;
        }

        private void GiveUp_Click(object sender, EventArgs e)
        {
            StreamWriter sr2 = new StreamWriter(map_name + "/ERROR_LOG.txt", true);

            foreach (DataRow row in missing_tiles.Rows)
            {
                sr2.WriteLine(row["URL"].ToString() + " TO /" + row["File"].ToString());
            }

            sr2.Close();

            MessageBox.Show("See ERROR_LOG.txt in the map folder for a list of tiles that were missed");
            this.Close();
        }

        private bool ThumbnailCallback()
        {
            return false;
        }

        private void TryAgain_Click(object sender, EventArgs e)
        {
            Progress.Visible = true;
            int total = missing_tiles.Rows.Count;
            int count = 0;
            foreach (DataRow row in missing_tiles.Rows)
            {
                count++;
                Progress.Text = "On tile " + count.ToString() + " out of " + total.ToString();
                Application.DoEvents();
                try
                {
                    if (row["URL"].ToString().IndexOf("baidu.com") != -1)
                        new Bitmap(new MemoryStream(new WebClient().DownloadData(row["URL"].ToString()))).GetThumbnailImage(256, 256, new Image.GetThumbnailImageAbort(ThumbnailCallback), System.IntPtr.Zero).Save(map_name + "/" + row["File"].ToString());
                    else 
                        new WebClient().DownloadFile(row["URL"].ToString(), map_name + "/" + row["File"].ToString()); // yes, no load balancing...
                    row.Delete();
                }
                catch { }
            }
            Progress.Visible = false;

            if (missing_tiles.Rows.Count == 0)
            {
                MessageBox.Show("Got all tiles successfully");
                this.Close();
            }
            else
            {
                MessageBox.Show("Missing tiles still remain, you may want to try again");
            }
        }
    }
}